/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FILI                                                     */
/* Tabela : FILIAL                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FILI'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FILI
GO

CREATE TRIGGER DTULTATU_FILI
ON FILIAL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FILIAL', null, 'CDFILIAL=' + CDFILIAL + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FILIAL
      SET DTULTATUFILI = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(FILIAL.CDFILIAL,0)    = ISNULL(INSERTED.CDFILIAL,0));
   END;
END;
GO

UPDATE FILIAL SET DTULTATUFILI = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUFILI IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUFILI' and
            type = 'D')
   ALTER TABLE FILIAL DROP CONSTRAINT DEFAULT_DTULTATUFILI
GO

ALTER TABLE FILIAL ADD CONSTRAINT DEFAULT_DTULTATUFILI
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUFILI
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_FILI','6.05.000';
GO



