var Dfs21100_RomaneioNotasFiscaisSaida_Controller = function(restEngine, templateManager, General, ZhFilterPreferences) {

	this.openFilterRomaneio = function (widget){
        var dataAtual = moment().format('DD/MM/YYYY');
        var start = dataAtual;
        var end   = dataAtual;
        var rowFilter = {};
        
        rowFilter = {
            'DTENTRSAID': {
                start : start, 
                formattedStart: start,
                end : end,
                formattedEnd: end
            }
        };
    
        rowFilter.DTENTRSAID.validations = { "requiredInterval": true };
        
        General.callRestEngine("df_saida#/getFilterExportSap", "Row", {}).then((response) => {
            if(response.dataset.filter) {
                rowFilter.CDEMPRESA = response.dataset.filter.CDEMPRESA;
                rowFilter.NMEMPRESA = response.dataset.filter.NMEMPRESA;
                rowFilter.CDFILIAL  = response.dataset.filter.CDFILIAL;
                rowFilter.NMFILIAL  = response.dataset.filter.NMFILIAL;
                rowFilter.CDCLIENTE = response.dataset.filter.CDCLIENTE;
                rowFilter.CDFORNECED = response.dataset.filter.CDFORNECED;
                rowFilter.CDINSCESTA = response.dataset.filter.CDINSCESTA;
                rowFilter.CDINSCMUNI = response.dataset.filter.CDINSCMUNI;
             
            }
            ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowFilter).then(response => {
                var filter = templateManager.container.getActiveWidget();
                var clearFilter = filter.actions.filter(action => action.name === 'clear')[0];
                clearFilter.shortcutKey = 'ctrl+backspace';
                clearFilter.tooltip = 'Limpar Filtro (CTRL + Backspace)';
                filter.reload();
            
            });
        //ZhFilterPreferences.openFilterWidget(widget, rowFilter);
        },
        (error) => {
            ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowFilter);
        });
        
    };

     this.preparaFiltro = function(args) {
        
        args.e.preventDefault();
        var widget = args.owner;
        var filters = [];
        if(widget.appliedFilter) {
            args.e.filters.map((f) => {
                if(f.name != 'DTENTRSAID') {
                    filters.push(f);
                }
                else {
                    filters.push({
                        name: "P_DTENTRSAIDINI",
                        operator: "=",
                        value: f.value[0]
                    });
                    filters.push({
                        name: "P_DTENTRSAIDFIN",
                        operator: "=",
                        value: f.value[1]
                    });
                }
            });     
        }
        
       
        var cdcliente = widget.appliedFilter.FILTER_ROW.CDCLIENTE;
        var cdforneced = widget.appliedFilter.FILTER_ROW.CDFORNECED;
        
        if(cdcliente && cdcliente.length > 0){
             filters.push({name: "CDCLIENTE", operator: "IN", value: cdcliente});
        }
       
       if(cdforneced && cdforneced.length > 0){
             filters.push({name: "CDCLIENTE", operator: "IN", value: cdcliente});
        }
        
        args.owner.dataSourceFilter = filters;
        args.owner.reload();
    };

    
    
    this.getFieldValueFilter = function(fieldName, widgetName) {
        var container =  templateManager.container;
        
        if(container) {
            var filterWidget;
            var filterBeforeApply = templateManager.container.getActiveWidget();
            
            //test about how widget is... (field or filter)

    	    if(filterBeforeApply.label != 'Filtro'){		
    		    filterBeforeApply = filterBeforeApply.lastActiveWidget;
                filterWidget = filterBeforeApply;
                
            }
            
            if(filterBeforeApply.name == 'zhFilterPreferencesSelectConditions') {
            	filterWidget = filterBeforeApply;
            }
            
            else {
                var f = container.getWidget(widgetName);
                if(f) {
                     filterWidget = container.getWidget(widgetName).appliedFilter;
                }
               
            }
            
            // Insert values
            if(filterWidget) {
                var valueField;
                if(filterBeforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[fieldName];
                    
                else
                    valueField = filterWidget.FILTER_ROW[fieldName];
                    
                return valueField || null;
            }
            else return null;
        }
        else return null;
    };
    
    this.habilitaOrigDestNF = function(args) {
        var widget = args.owner.owner.widget;
        switch(widget.currentRow.IDORIGDESTNF) {
            case 'C':
                
                widget.getField('CDFORNECED').isVisible = false;
                widget.getField('CDFILIRECE').isVisible = false;
                widget.getField('CDCLIENTE').isVisible  = true;
                
                widget.getField('CDFORNECED').value("");
                widget.getField('CDFILIRECE').value("");
        
                break;
            case 'F':
                
                widget.getField('CDCLIENTE').isVisible   = false;
                widget.getField('CDFILIRECE').isVisible = false;
                 widget.getField('CDFORNECED').isVisible = true;
                
                widget.getField('CDCLIENTE').value("");
                widget.getField('CDFILIRECE').value("");

                break;
            case 'L':
        
                widget.getField('CDCLIENTE').isVisible     = false;
                widget.getField('CDFORNECED').isVisible     = false;
                widget.getField('CDFILIRECE').isVisible       = true;
                
                widget.getField('CDCLIENTE').value("");
                widget.getField('CDFORNECED').value("");

                break;
            default:
                widget.getField('CDCLIENTE').isVisible     = false;
                widget.getField('CDFORNECED').isVisible     = false;
                widget.getField('CDFILIRECE').isVisible       = false;
                widget.getField('CDFILIRECE').value("");
                widget.getField('CDCLIENTE').value("");
                widget.getField('CDFORNECED').value("");
                
                break;
        }
    };

    this.verficaCampoEmpresa = function(args){
        var widget = args.owner.owner.widget;
        if (widget.currentRow.NMEMPRESA){
            widget.getField('CDINSCESTA').readOnly = false;
            widget.currentRow.CDINSCESTA = '';
            widget.currentRow.CDINSCESTA = '';
            widget.getField('CDINSCESTA').reload();
            widget.getField('CDINSCMUNI').readOnly = false;
            widget.currentRow.CDINSCMUNI = '';
            widget.currentRow.CDINSCMUNI = '';
            widget.getField('CDINSCMUNI').reload();
            widget.getField('NMFILIAL').readOnly = false;
            widget.currentRow.NMFILIAL = '';
            widget.currentRow.CDFILIAL = '';
            widget.getField('NMFILIAL').reload();
        } else {
            widget.currentRow.CDINSCESTA = '';
            widget.getField('CDINSCESTA').readOnly = true;
            widget.currentRow.NMFILIAL = '';
            widget.getField('NMFILIAL').readOnly = true;
            widget.currentRow.CDINSCMUNI = '';
            widget.getField('CDINSCMUNI').readOnly = true;
        }
        widget.reload();

    };
    
    this.recarregarInscricaoFiltro = function (nomeCampo){
        var widget = templateManager.container.getWidget('romaneioNotasFiscaisSaidaGrid');
        var filtro = widget.appliedFilter;
        filtro.getField(nomeCampo).reload();
    };

    this.toggleInscricaoEstadual = function (field) {
        field.dataSource.data.forEach(inscricao => inscricao.CDINSCESTA = inscricao.CDINSCESTA === null ? inscricao.CDINSCESTA : inscricao.CDINSCESTA );
    };
    
    this.toggleInscricaoMunicipal = function (field) {
        field.dataSource.data.forEach(inscricao => inscricao.CDINSCMUNI = inscricao.CDINSCMUNI === null ? inscricao.CDINSCMUNI : inscricao.CDINSCMUNI );
    };
    
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Dfs21100_RomaneioNotasFiscaisSaida_Controller', Dfs21100_RomaneioNotasFiscaisSaida_Controller);
});